# Setting up OCCI-Studio

## Downloading OCCI-Studio
1. Download the [latest release of OCCI-Studio](https://github.com/occiware/OCCI-Studio/releases).
2. Extract OCCI-Studio and start it.

## Installing required plugins
To initialize the proposed OCCI extensions, the following plugins need to be added to the OCCI-Studio. 
These allow to correctly depict OCCI models in the textual and graphical editor. To Install plugins the following steps have
to be performed:

1. Navigate to: Help -> Install New Software...
2. Press Add...
3. Insert the location of the update site: 

### MoDMaCAO
The updatesite can be found at: [http://c109-125.cloud.gwdg.de/](http://c109-125.cloud.gwdg.de/).
To install the plugin please deselect "Group items by category" and choose MoDMaCAO.

### Gradle
To easily access our provided example install the gradle plugin within OCCI-Studio by following the instructions given here:
```
https://github.com/eclipse/buildship/blob/master/docs/user/Installation.md
```

### Mocci
Finally, the Mocci plugin can be installed which registers the OCCI monitoring extension. Therefore, the following steps have to be performed:
1. Navigate to [https://rwm.pages.gwdg.de/de.ugoe.cs.rwm.mocci/model/index.html/](https://rwm.pages.gwdg.de/de.ugoe.cs.rwm.mocci/model/index.html/):
2. Press Download Eclipse Plugin Archive
3. Save the updatesite.zip to any destination
4. Then follow the steps to install the plugin given above, but system choose the location of the updatesite.zip

Alternatively, you can build the Eclipse plugin yourself by checking out the project and perform the following command on the mocci.model project:
```
gradle updateSiteZip
```

## Visualizing the example
Now that the IDE has been installed and configured, the example model can now be loaded, visualized, and edited.
The model can be found within the project under:
```
de.ugoe.cs.rwm.mocci/src/test/resources/occi/hadoopClusterNewExt.occic
```

### Tree Editor
To check whether the installation and configuration of the IDE is successful the model can be opened in the textual editor:

1. Right click the hadoopClusterNewExt.occic file
2. Choose Open with... -> OCCI Model Editor
3. If no problem occurs, all extensions are correctly loaded

### Sirius Visualization
To visualize the model in an graphical editor it is most convenient to create a separate Sirius Modeling project. Therefore, the following steps have to be performed:

1. File -> New -> Project... -> Sirius -> Modeling Project
2. Name it MonitoringExample
3. Copy the hadoopClusterNewExt.occic file into the Project
4. Double click on representation.aird
5. Press Add... in the Models section
6. Choose Browse Workspace...
7. Select hadoopClusterNewExt.occic
8. Now the Model and its possible representations should been loaded (transparent)
9. Under Representation doubleclick on OCCI Configuratrion
10. Next choose Configuration diagram (0) (non-transparent)
11. Select the Configuration element and press Finish

To reduce the size of the model visualization collapse the User_Data and SSH information of each Compute node.
Thereafter, press arrange all in the editor.
Now the cloud deployment is ready to be explored.